diff --git a/pimd/pim6_mld.c b/pimd/pim6_mld.c
index dc5e67e2c5d9..d4fe991e8b15 100644
--- a/pimd/pim6_mld.c
+++ b/pimd/pim6_mld.c
@@ -2737,8 +2737,11 @@ static void gm_show_joins_one(struct vty *vty, struct gm_if *gm_ifp,
 		}
 
 		js_src = json_object_new_object();
-		json_object_object_addf(js_group, js_src, "%pPA",
-					&sg->sgaddr.src);
+		if (pim_addr_is_any(sg->sgaddr.src))
+			json_object_object_add(js_group, "*", js_src);
+		else
+			json_object_object_addf(js_group, js_src, "%pPA",
+						&sg->sgaddr.src);
 
 		json_object_string_add(js_src, "state", gm_states[sg->state]);
 		json_object_string_addf(js_src, "created", "%pTVMs",
@@ -2796,11 +2799,9 @@ static void gm_show_joins_vrf(struct vty *vty, struct vrf *vrf,
 			      json_object *js)
 {
 	struct interface *ifp;
-	json_object *js_vrf;
 
 	if (js) {
-		js_vrf = json_object_new_object();
-		json_object_object_add(js, vrf->name, js_vrf);
+		json_object_string_add(js, "vrf", vrf->name);
 	}
 
 	FOR_ALL_INTERFACES (vrf, ifp) {
@@ -2820,7 +2821,7 @@ static void gm_show_joins_vrf(struct vty *vty, struct vrf *vrf,
 
 		if (js) {
 			js_if = json_object_new_object();
-			json_object_object_add(js_vrf, ifp->name, js_if);
+			json_object_object_add(js, ifp->name, js_if);
 		}
 
 		if (!js && !ifname)
